"use strict";

require("core-js/modules/esnext.iterator.some.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.testApiHandler = testApiHandler;
require("core-js/modules/es.array.push.js");
require("core-js/modules/esnext.iterator.map.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.flat-map.js");
var _nodeHttp = require("node:http");
var _nodeUrl = require("node:url");
var _cookie = require("cookie");
var _nodeFetch = _interopRequireWildcard(require("node-fetch"));
const _rewrite = (specifier, options) => {
    if (typeof specifier != 'string') {
      throw new TypeError(`rewrite error: expected specifier of type string, not ${typeof specifier}`);
    }
    let replacementMap;
    replacementMap = undefined;
    if (options.replaceExtensions) {
      Object.entries(options.replaceExtensions).some(([target, replacement]) => {
        if (target.startsWith('^') || target.endsWith('$')) {
          const targetRegExp = new RegExp(target);
          const capturingGroups = Array.from(specifier.match(targetRegExp) || []);
          if (capturingGroups.length) {
            replacementMap = [targetRegExp, replacement, capturingGroups];
            return true;
          }
        } else if (specifier.endsWith(target)) {
          replacementMap = [target, replacement, []];
          return true;
        }
      });
    }
    let finalImportPath = specifier;
    if (replacementMap) {
      const [target, replacement, capturingGroups] = replacementMap;
      finalImportPath = finalImportPath.replace(target, typeof replacement == 'string' ? replacement : replacement({
        specifier,
        capturingGroups
      }));
    }
    const isRelative = finalImportPath.startsWith('./') || finalImportPath.startsWith('.\\') || finalImportPath.startsWith('../') || finalImportPath.startsWith('..\\') || finalImportPath == '.' || finalImportPath == '..';
    if (options.appendExtension && isRelative) {
      const endsWithSlash = /(\/|\\)$/.test(finalImportPath);
      const basenameIsDots = /(^\.?\.(\/|\\)?$)|((\/|\\)\.?\.(\/|\\)?$)/.test(finalImportPath);
      const extensionToAppend = typeof options.appendExtension == 'string' ? options.appendExtension : options.appendExtension({
        specifier,
        capturingGroups: []
      });
      if (extensionToAppend !== undefined) {
        if (basenameIsDots) {
          finalImportPath += `${endsWithSlash ? '' : '/'}index${extensionToAppend}`;
        } else {
          const hasRecognizedExtension = !endsWithSlash && options.recognizedExtensions.some(extension => {
            return finalImportPath.endsWith(extension);
          });
          if (!hasRecognizedExtension) {
            finalImportPath = endsWithSlash ? finalImportPath + `index${extensionToAppend}` : finalImportPath + extensionToAppend;
          }
        }
      }
    }
    return finalImportPath;
  },
  _rewrite_options = {
    "recognizedExtensions": [".js", ".jsx", ".mjs", ".cjs", ".json"],
    "replaceExtensions": {
      "^../package.json$": "../../package.json"
    }
  };
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const addDefaultHeaders = headers => {
  if (!headers.has('x-msw-intention')) {
    headers.set('x-msw-intention', 'bypass');
  }
  return headers;
};
let apiResolver = null;
const tryImport = path => error => {
  if (error) {
    (tryImport.importErrors = tryImport.importErrors ?? []).push(error);
  }
  if (typeof __webpack_require__ === 'function') {
    const runningAsESM = module === undefined && require === undefined;
    return runningAsESM ? import(_rewrite(path, _rewrite_options)) : __non_webpack_require__(path);
  } else if (typeof require === 'function') {
    return require(_rewrite(path, _rewrite_options));
  } else {
    return import(_rewrite(path, _rewrite_options));
  }
};
const handleError = (res, error, deferredReject) => {
  if (!res.writableEnded) {
    res.end();
  }
  if (deferredReject) deferredReject(error);else throw error;
};
async function testApiHandler({
  rejectOnHandlerError,
  requestPatcher,
  responsePatcher,
  paramsPatcher,
  params,
  url,
  handler,
  test
}) {
  let server = null;
  let deferredReject = null;
  try {
    if (!apiResolver) {
      ({
        apiResolver
      } = await Promise.reject().catch(tryImport('next/dist/server/api-utils/node/api-resolver.js')).catch(tryImport('next/dist/server/api-utils/node.js')).catch(tryImport('next/dist/server/api-utils.js')).catch(tryImport('next/dist/next-server/server/api-utils.js')).catch(tryImport('next-server/dist/server/api-utils.js')).catch(error => (tryImport.importErrors.push(error), {
        apiResolver: null
      })));
      if (!apiResolver) {
        const importErrors = tryImport.importErrors.map(error => error.message.split(/(?<=')( imported)? from ('|\S)/)[0].split(`\nRequire`)[0]).join('\n    - ');
        tryImport.importErrors = [];
        throw new Error(`next-test-api-route-handler (NTARH) failed to import api-utils.js` + `\n\n  This is usually caused by:` + `\n\n    1. Using a Node version that is end-of-life (review legacy install instructions)` + `\n    2. NTARH and the version of Next.js you installed are actually incompatible (please submit a bug report)` + `\n\n  Failed import attempts:` + `\n\n    - ${importErrors}`);
      }
    }
    server = (0, _nodeHttp.createServer)((request, res) => {
      try {
        if (typeof apiResolver != 'function') {
          throw new TypeError('assertion failed unexpectedly: apiResolver was not a function');
        }
        if (url) {
          request.url = url;
        }
        requestPatcher?.(request);
        responsePatcher?.(res);
        const finalParameters = {
          ...(0, _nodeUrl.parse)(request.url || '', true).query,
          ...params
        };
        paramsPatcher?.(finalParameters);
        void apiResolver(request, res, finalParameters, handler, undefined, !!rejectOnHandlerError).catch(error => handleError(res, error, deferredReject));
      } catch (error) {
        handleError(res, error, deferredReject);
      }
    });
    const port = await new Promise((resolve, reject) => {
      server?.listen(() => {
        const addr = server?.address();
        if (!addr || typeof addr === 'string') {
          reject(new Error('assertion failed unexpectedly: server did not return AddressInfo instance'));
        } else {
          resolve(addr.port);
        }
      });
    });
    const localUrl = `http://localhost:${port}`;
    await new Promise((resolve, reject) => {
      deferredReject = reject;
      test({
        fetch: async customInit => {
          const init = {
            ...customInit,
            headers: addDefaultHeaders(new _nodeFetch.Headers(customInit?.headers))
          };
          return (0, _nodeFetch.default)(localUrl, init).then(res => {
            Object.defineProperty(res, 'cookies', {
              configurable: true,
              enumerable: true,
              get: () => {
                delete res.cookies;
                res.cookies = [res.headers.raw()['set-cookie'] || []].flat().map(header => Object.fromEntries(Object.entries((0, _cookie.parse)(header)).flatMap(([k, v]) => {
                  return [[String(k), v], [String(k).toLowerCase(), v]];
                })));
                return res.cookies;
              }
            });
            return res;
          });
        }
      }).then(resolve, reject);
    });
  } finally {
    server?.close();
  }
}